/*
  GUIDO Library
  Copyright (C) 2017 Grame

  This Source Code Form is subject to the terms of the Mozilla Public
  License, v. 2.0. If a copy of the MPL was not distributed with this
  file, You can obtain one at http://mozilla.org/MPL/2.0/.

  Grame Research Laboratory, 11, cours de Verdun Gensoul 69002 Lyon - France
  research@grame.fr
*/

#ifndef ___Tags___
#define ___Tags___

#include <string>

std::string makeTag (const char* tag);

extern const char* kTagAcc;
extern const char* kTagAccel;
extern const char* kTagAccelBegin;
extern const char* kTagAccelEnd;
extern const char* kTagAccelerando;
extern const char* kTagAccent;
extern const char* kTagAccidental;
extern const char* kTagAccol;
extern const char* kTagAccolade;
extern const char* kTagAlter;
extern const char* kTagAuto;
extern const char* kTagB;
extern const char* kTagBar;
extern const char* kTagBarFormat;
extern const char* kTagBeam;
extern const char* kTagBeamBegin;
extern const char* kTagBeamEnd;
extern const char* kTagBeamsAuto;
extern const char* kTagBeamsFull;
extern const char* kTagBeamsOff;
extern const char* kTagBembel;
extern const char* kTagBm;
extern const char* kTagBreathMark;
extern const char* kTagChord;
extern const char* kTagClef;
extern const char* kTagCluster;
extern const char* kTagCoda;
extern const char* kTagColor;
extern const char* kTagColour;
extern const char* kTagComposer;
extern const char* kTagCresc;
extern const char* kTagCrescBegin;
extern const char* kTagCrescEnd;
extern const char* kTagCrescendo;
extern const char* kTagCue;
extern const char* kTagDaCapo;
extern const char* kTagDaCapoAlFine;
extern const char* kTagDaCoda;
extern const char* kTagDalSegno;
extern const char* kTagDalSegnoAlFine;
extern const char* kTagDecresc;
extern const char* kTagDecrescBegin;
extern const char* kTagDecrescEnd;
extern const char* kTagDecrescendo;
extern const char* kTagDim;
extern const char* kTagDimBegin;
extern const char* kTagDimEnd;
extern const char* kTagDiminuendo;
extern const char* kTagDiminuendoBegin;
extern const char* kTagDiminuendoEnd;
extern const char* kTagDispDur;
extern const char* kTagDisplayDuration;
extern const char* kTagDotFormat;
extern const char* kTagDoubleBar;
extern const char* kTagEndBar;
extern const char* kTagFBeam;
extern const char* kTagFBeamBegin;
extern const char* kTagFBeamEnd;
extern const char* kTagFermata;
extern const char* kTagFine;
extern const char* kTagFingering;
extern const char* kTagGlissando;
extern const char* kTagGlissandoBegin;
extern const char* kTagGlissandoEnd;
extern const char* kTagGrace;
extern const char* kTagHarmonic;
extern const char* kTagHarmony;
extern const char* kTagHeadsCenter;
extern const char* kTagHeadsLeft;
extern const char* kTagHeadsNormal;
extern const char* kTagHeadsReverse;
extern const char* kTagHeadsRight;
extern const char* kTagI;
extern const char* kTagInstr;
extern const char* kTagInstrument;
extern const char* kTagIntens;
extern const char* kTagIntensity;
extern const char* kTagKey;
extern const char* kTagLabel;
extern const char* kTagLyrics;
extern const char* kTagMarcato;
extern const char* kTagMark;
extern const char* kTagMerge;
extern const char* kTagMeter;
extern const char* kTagMord;
extern const char* kTagMordent;
extern const char* kTagNewLine;
extern const char* kTagNewPage;
extern const char* kTagNewSystem;
extern const char* kTagNoteFormat;
extern const char* kTagOct;
extern const char* kTagOctava;
extern const char* kTagPageFormat;
extern const char* kTagPizz;
extern const char* kTagPizzicato;
extern const char* kTagPort;
extern const char* kTagRepeatBegin;
extern const char* kTagRepeatEnd;
extern const char* kTagRestFormat;
extern const char* kTagRit;
extern const char* kTagRitardando;
extern const char* kTagRitBegin;
extern const char* kTagRitEnd;
extern const char* kTagS;
extern const char* kTagSegno;
extern const char* kTagSet;
extern const char* kTagShareLocation;
extern const char* kTagShortFermata;
extern const char* kTagSl;
extern const char* kTagSlur;
extern const char* kTagSlurBegin;
extern const char* kTagSlurEnd;
extern const char* kTagSpace;
extern const char* kTagSpecial;
extern const char* kTagStacc;
extern const char* kTagStaccato;
extern const char* kTagStaccBegin;
extern const char* kTagStaccEnd;
extern const char* kTagStaff;
extern const char* kTagStaffFormat;
extern const char* kTagStaffOff;
extern const char* kTagStaffOn;
extern const char* kTagStemsAuto;
extern const char* kTagStemsDown;
extern const char* kTagStemsOff;
extern const char* kTagStemsUp;
extern const char* kTagSymbol;
extern const char* kTagSystemFormat;
extern const char* kTagT;
extern const char* kTagTempo;
extern const char* kTagTen;
extern const char* kTagTenuto;
extern const char* kTagText;
extern const char* kTagTie;
extern const char* kTagTieBegin;
extern const char* kTagTieEnd;
extern const char* kTagTitle;
extern const char* kTagTrem;
extern const char* kTagTremBegin;
extern const char* kTagTremEnd;
extern const char* kTagTremolo;
extern const char* kTagTremoloBegin;
extern const char* kTagTremoloEnd;
extern const char* kTagTrill;
extern const char* kTagTrillBegin;
extern const char* kTagTrillEnd;
extern const char* kTagTuplet;
extern const char* kTagTurn;
extern const char* kTagUnits;
extern const char* kTagVolta;
extern const char* kTagVoltaBegin;
extern const char* kTagVoltaEnd;

#endif
